<?php
/**
 * mod_emailallposts: Send all posts on the message board to an email address.
 * author: Chris Eaton (tridus@hiredgoons.ca)
 * version: 1.4
 * license: You are free to use, modify, or redistribute this code so long as I am given credit for the original development somewhere.
 * This code comes with absolutly no warranty.
 * 
 * It would be nice (but not required) of you to email me if you find this module useful. :-)
 */
if ( !defined( "PHORUM" ) ) return;

function mod_emailallposts ( $data )
{ 
    $PHORUM = $GLOBALS["PHORUM"];
    $forum = phorum_db_get_forums( $PHORUM["forum_id"] );

    // if they are going to add attachments, we don't care
    if ( $data["status"] == PHORUM_STATUS_ATTACHING ) {
        return $data;
    } 

    $mail_post = preg_replace( "|</*[a-z][^>]*>|i", "", $_POST["body"] );
    $mail_post = preg_replace( "|\[/*[a-z][^\]]*\]|i", "", $mail_post );

    if ( $PHORUM["mod_emailallposts"]["mode"] == "Monitoring" ) {
        $subject = "[" . $PHORUM["mod_emailallposts"]["subject"] . "] " . stripslashes( $data["author"] ) . ": " . stripslashes( $data["subject"] );
        $body = "Author: " . stripslashes( $data["author"] );
        $body .= "\nUsername: " . $PHORUM["user"]["username"] . " (" . $data["ip"] . ")";
        $body .= "\nSubject: " . stripslashes( $data["subject"] );
        $body .= "\nForum: " . $forum["$PHORUM[forum_id]"]["name"];
        $body .= "\nLink: " . phorum_get_url( PHORUM_READ_URL, $data["thread"], $data["message_id"] );

        if ( $data["status"] == PHORUM_STATUS_HOLD ) {
            $body .= "\nApproved: No";
        } else {
            $body .= "\nApproved: Yes";
        } 
        if ( $PHORUM["max_attachments"] > 0 && isset( $_POST["attach"] ) ) {
            $body .= "\nAttachments included!";
        } 
    } else {
        // return if the message is not live.
        if ( $data["status"] == PHORUM_STATUS_HOLD ) {
            return $data;
        } 

        $subject = "[" . $forum["$PHORUM[forum_id]"]["name"] . "] " . stripslashes( $data["subject"] );

        $body = "Author: " . stripslashes( $data["author"] );
        $body .= "\nLink:  " . phorum_get_url( PHORUM_READ_URL, $data["thread"], $data["message_id"] );
        $body .= "\n".str_repeat("-", 80);

        $tagline="\n\n-- \nSent from $PHORUM[title]\n$PHORUM[http_path]";

    } 

    $toAddress = array();
    if ( !empty( $PHORUM["mod_emailallposts"]["email_to"] ) ) {
        array_push( $toAddress, $PHORUM["mod_emailallposts"]["email_to"] );
    } 
    if ( !empty( $PHORUM["mod_emailallposts"]["addresses"]["$PHORUM[forum_id]"] ) ) {
        array_push( $toAddress, $PHORUM["mod_emailallposts"]["addresses"]["$PHORUM[forum_id]"] );
    } 

    $body .= "\n\n" . $mail_post . $tagline;



    $message = array( "mailsubject" => $subject, "mailmessage" => $body, "msgid" => $data["msgid"] );
    
    phorum_email_user( $toAddress, $message );
    return $data;
} 

?>
